$INTERFACE U0SSU3                                             97/12/01
$REM LU
  $N='NF'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD')
  $JARA='V'
  $D='D'
  $DL='DL'
  $DU='DU'
  $DU2='DU2'
  $GN=G
  $AGS=AG
  $AGH='AGH'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $DECOMP='E'
  $HELP
     METHOD
       3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
       4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
       5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
  $CHECK(NUMBER,3,'\3\4\5',2,NO)
  $NUMDER=1
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=2 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=3 - DIAGONAL PRECONDITIONING
        ABS(MOS2)=4 - TRIDIAGONAL PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-4\-3\-2\-1\0\1\2\3\4',1)
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $IF(MOS2=-4) $NOS2=4
  $IF(NOS2=0)
  $ELSEIF(NOS2<3)
    $XM='XM'
    $GM='GM'
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,3,INT,2,NO)
    $ADD(INIT)
      MF=$MF
    $ENDADD
  $ELSEIF(NOS2<5)
    $NUMDER=3
  $ENDIF
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL BIQUADRATIC INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=4
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,ETA0,REAL,4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $HELP
      LINE SEARCH
        1 - FOR MINIMIZATION
        3 - FOR NONLINEAR EQUATIONS
    $CHECK(STEP,1,'1\3',4,NO)
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
  $ENDIF
  $ISNF=0
  $IF(ISNA<1) $ISNA=1
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL1')
  $IF(NORMF>0) $SUBST('UATRL1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     -----------------------
*     TRUNCATED NEWTON METHOD
*     TEMPLATE : U0SSU3
*     -----------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',0)
  CALL UYPRO2(FMIN,FO)
$L=$10 ; $LABEL
  $KD=0
  $SUBST('UZMODL')
  GO TO IMD
$L=$20 ; $LABEL
  N=NF
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $90
  $IF(CONSTR<>'U') $SUBST('UYRM$(CONSTR)0')
$L=$30 ; $LABEL
  $IF(NOS2>2)
    $SUBST('UUDRD1')
  $ENDIF
  IF(ITERM.NE.0) GOTO $90
  $MAT='G'
  $IF(NUMBER=2) $MAT='V'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  CALL UYSET1
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $30
$L=$50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
    CALL UXVCOP(NA,$AF,$AFO)
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 64 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  TXFU = TUXX
  $IF(NOS2>2)
    IREST=1
  $ENDIF
  $IF(NOS2=0)
    $SUBST('UYTRUD')
  $ELSEIF(NOS2<3)
    $MET=NOS2
    CALL UYTRUF(NF,NA,$X,$XN,$XO,$AF,$AFO,R,F,FO,P,PO,DMAX)
    $SUBST('UULBA1')
  $ELSE
    $SUBST('UYTRUD')
  $ENDIF
  $IF(CONSTR<>'U')
    IF (IDIR.EQ.0) THEN
    $SUBST('UYAD$(CONSTR)0')
    ENDIF
  $ENDIF
  GOTO $20
$L=$90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(0)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U0SSU3'
  $ENDADD
  $EXIT
