$INTERFACE U1FLU4                                             99/12/01
$REM LU
  $N='NF'
  $XM='XM'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,10,INT,2,NO)
  $ADD(INIT)
    MF=$MF
  $ENDADD
  $CON1='2.5$P-1'
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\$XM($NF*$MF)')
  $HERF='L'
$REM  $IF(CONSTR='S') $CONSTR='U'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $TYPE='L'
  $DECOMP='I'
  $NUMBER=1
  $ISNF=0
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $HELP
    TYPE OF UPDATES:
      B - UPDATES DERIVED FROM THE BROYDEN CLASS
      V - VRIATIONALLY DERIVED UPDATES
  $CHECK(UPDATE,'V','B\V',3,NO)
  $HELP
    TYPE OF UPDATES:
      B - BASIC UPDATES WITH BFGS-BASED STARTING UPDATE
      D - BASIC UPDATES WITH DFP -BASED STARTING UPDATE
      V - VRIATIONALLY DERIVED UPDATES
  $CHECK(UPDATE,'V','B\D\V',3,NO)
  $HELP
    COMPUTATION OF THE WEIGHTING PARAMETER:
      0 - PREVIOUS CHOICE
      1 - SIMPLE CHOICE WITH THE CONSTANT RELATIVE PARAMETER
      2 - CHOICE DEFINED BY THE QUADRATIC EQUATION
      3 - HEURISTIC CHOICE WITH THE RELATIVE PARAMETER LESS
          THEN HALF
      4 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
          IN THE FIRST ITERATION (FIRST FORMULA)
      5 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
          IN THE FIRST ITERATION (SECOND FORMULA)
      6 - HEURISTIC CHOICE DERIVED FROM THE LOWEST EIGENVALUE
          OF THE UPDATED METRIX
  $CHECK(MET3,4,'0\1\2\3\4\5\6',4)
  $IF(UPDATE='V')
    $HELP
      LIMITED MEMORY METHOD:
        MET5=1 - RANK ONE LIMITED MEMORY METHOD
        MET5=2 - SIMPLE RANK TWO LIMITED MEMORY METHOD
        MET5=3 - GENERAL RANK TWO LIMITED MEMORY METHOD WITH
                 A CONSTANT BROYDEN PARAMETER
        MET5=4 - GENERAL RANK TWO LIMITED MEMORY METHOD WITH
                 THE BROYDEN PARAMETER DERIVED BY THE MINIMUM
                 PRINCIPLE
        MET5=5 - SIMPLE RANK TWO LIMITED MEMORY METHOD WITH A
                 SPECIAL CHOICE OF T*Y.
        MET5=6 - SIMPLE RANK TWO LIMITED MEMORY METHOD WITH A
                 SPECIAL CHOICE OF T*Y.
        MET5=7 - SIMPLE RANK TWO LIMITED MEMORY METHOD WITH A
                 SPECIAL CHOICE OF T*Y.
    $CHECK(MET5,3,'\1\2\3\4\5\6\7\8',4)
  $ELSE
    $HELP
      LIMITED MEMORY METHOD:
        MET5=1 - RANK ONE LIMITED MEMORY METHOD
        MET5=2 - SIMPLE RANK TWO LIMITED MEMORY METHOD
        MET5=3 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (SIMPLE CHOICE)
        MET5=4 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (FROBENIUS NORM)
        MET5=5 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (DIRECTION VECTOR)
    $CHECK(MET5,3,'1\2\3\4\5',4)
    $HELP
      LIMITED MEMORY METHOD:
        ABS(MET5)=1 - RANK ONE LIMITED MEMORY METHOD
        ABS(MET5)=2 - SIMPLE RANK TWO LIMITED MEMORY METHOD
        ABS(MET5)=3 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (SIMPLE CHOICE)
        ABS(MET5)=4 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (FROBENIUS NORM)
        ABS(MET5)=5 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE SHIFTED BROYDEN CLASS (DIRECTION VECTOR)
        ABS(MET5)=6 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM
                 THE STANDARD BROYDEN CLASS (FROBENIUS NORM)
             MET5<0 - THE USE OF UULVP1
             MET5>0 - THE USE OF UULVP2
    $CHECK(MET5,3,'-6\-5\-4\-3\-2\-1\0\1\2\3\4\5',4)
  $ENDIF
  $IF (MF>NF)
    $MET3DEF='MET3'
  $ELSEIF(MET5=8)
    $MET3DEF=1
    $CON1='5.0$P-1'
  $ELSEIF(MET3=4)
    $MET3DEF='MET3'
  $ELSEIF(MET3=5)
    $MET3DEF='MET3'
  $ELSE
    $MET3DEF=1
    $CON1='5.0$P-1'
  $ENDIF
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  IF (ITERM.NE.0) GOTO $90
*
*     -----------------------------
*     SPARSE VARIABLE METRIC METHOD
*     TEMPLATE : U1FLU4
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C')
    IF (RMAX.GT.ZERO) THEN
    $SUBST('UYRM$(CONSTR)0')
    ENDIF
  $ENDIF
$L=$ 30 ; $LABEL
$REM  $SUBST('UULSD1')
  IF (IREST.GT.0) THEN
  NN=0
  PAR=ONE
  TUXX='UNIT    '
  LD=MIN(LD,1)
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GOTO $90
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $MAT='P'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)1
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)2')
  IF (ITERM.NE.0) GOTO $90
  IF (IREST.NE.0) GOTO $30
$L=$ 60 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  CALL UXVNEG(NF,$GO,$S)
  $SUBST('UYTR$(CONSTR)D')
  $IF(CONSTR='C')
    CALL UXUZER(NF,$GO,$IX,KBF)
    CALL UXUCOP(NF,$G,$SO,$IX,KBF)
  $ENDIF
  IF (NN.LT.MF) THEN
  $IHLP=1
  $IF (UPDATE='D') $IHLP=2
  $SUBST('UULSP$IHLP')
  ELSE
$REM  ITERM=-100
$REM  CALL UOERR1('U1FLU4',100)
$REM  GOTO $90
  $IF(UPDATE='V')
   $SUBST('UULVP3')
  $ELSEIF(MET5>0)
    $SUBST('UULVP2')
  $ELSE
    $SUBST('UULVP1')
  $ENDIF
  ENDIF
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FLU4'
  $ENDADD
  $EXIT
