$INTERFACE UDGGE4                                             97/12/01
$REM LU
  $CON1='1.0$P-3'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    CHOICE OF INITIAL BIORTHOGONAL VECTOR:
      1 - GRADIENT
      2 - RESIDUAL VECTOR
  $CHECK(MOS1,1,'1\2',3)
  $DEFAULT='0.4$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    PARAMETER FOR INCOMPLETE LU PRECONDITIONER
  $CHECK(ETA2,'0.0$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $IF(JARA='D')
    $AFS=AF
    $AFP=GO
    $HELP
      NUMBER OF STEPS BEFORE RESTART
    $CHECK(MOS3,50,INT,2)
    $ADD(REAL,'\$AG($NF*$NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$XS($NF+1)\$GS($NF)\$XP($NF)\$GA($NF)\$AF($NA)\$AFO($NA*$MOS3)&
    \$AFD($MOS3*($MOS3+1)/2)')
  $ELSEIF(JARA='V')
    $ADD(INTEGER,'\NOS2')
    $AFS='AFS'
    $AFP='AFP'
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=2 - QUASINEWTON PRECONDITIONING
        ABS(MOS2)=3 - TRIDIAGONAL PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-3\0\1\2\3',1)
    $DEFAULT=50
$REM    $IF(MOS2=0) $DEFAULT=30
    $HELP
      NUMBER OF STEPS BEFORE RESTART
    $CHECK(MOS3,DEFAULT,INT,2)
    $IF(NUMDER=3)
    $ELSE
      $D=X
      $DL=X
      $DU=X
      $DU2=X
      $IH=IX
    $ENDIF
    $ADD(REAL,'\$D($NF)\$DL($NF)\$DU($NF)\$DU2($NF)\$GN($NF)\$SN($NF)&
    \$X($NF)\$XO($NF)\$GO($NF)\$XS($NF+1)\$GS($NF)\$XP($NF)\$SO($NF)&
    \$GA($NF)\$AF($NA)\$AFO($NA*$MOS3)\$AFS($NA)\$AFP($NA)&
    \$AFD($MOS3*($MOS3+1)/2)')
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(JARA='S')
    $AFS=AF
    $AFP=GA
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
        ABS(MOS2)=2 - SSOR PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,1,'-2\-1\0\1\2',1)
    $DEFAULT=100
$REM    $IF(MOS2=0) $DEFAULT=30
    $HELP
      NUMBER OF STEPS BEFORE RESTART
    $CHECK(MOS3,DEFAULT,INT,2)
    $IF(MOS2=0)
      $IB=IAG
      $IW1=IAG
      $IW2=IAG
    $ENDIF
    $ADD(REAL,'\$AG($MMAX)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$XS($NF+1)\$GS($NF)\$XP($NF)\$GA($NF)\$AF($NA)\$AFO($NA*$MOS3)&
    \$AFD($MOS3*($MOS3+1)/2)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IB($NF)\$IW1($NF)\$IW2($NF)')
  $ELSEIF(JARA='L')
    $U='U'
    $UM='UM'
    $AFS=AF
    $AFP=GA
    $HELP
      LIMITED STORAGE UPDATE:
        1 - BROYDEN UPDATE
        2 - COLUMN  UPDATE
    $CHECK(MET,1,'1\2',3)
    $DEFAULT=5
    $IF(MET=2) $DEFAULT=3
    $HELP
      NUMBER OF CORRECTIONS
    $CHECK(MF,DEFAULT,INT,2)
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
        ABS(MOS2)=2 - SSOR PRECONDITIONING
        MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
        MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                   BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,1,'-2\-1\0\1\2',1)
    $DEFAULT=100
$REM    $IF(MOS2=0) $DEFAULT=30
    $HELP
      NUMBER OF STEPS BEFORE RESTART
    $CHECK(MOS3,DEFAULT,INT,2)
    $IF(MOS2=0)
      $IB=IAG
      $IW1=IAG
      $IW2=IAG
    $ENDIF
    $ADD(REAL,'\$AG($MMAX)\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$UM($MF)\$U($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$XS($NF+1)&
    \$GS($NF)\$XP($NF)\$GA($NF)\$AF($NA)\$AFO($NA*$MOS3)&
    \$AFD($MOS3*($MOS3+1)/2)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IB($MF)\$JB($NF)\$IW1($NF)&
    \$IW2($NF)')
  $ENDIF
  $ADD(INTEGER,'\IRED\KRED')
  $ADD(REAL,'\UXVDOT\UXVNOR')
  $ADD(REAL,'\TEMP\RHO1\RHO2')
  CALL UOD1D1
  $IF(JARA='D')
    $N='N'
  $ELSEIF(JARA='V')
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $N='NF'
    NOS2=$NOS2
    IF (IDECA.LT.0) IDECA=0
    IF (IDECA.EQ.2) THEN
    ELSE IF (IDECA.NE.0) THEN
    ITERD=-1
    CALL UOERR1('UD$(JARA)GE4',1)
    TDXX='BAD DEC2'
    GO TO $70
*
*     CONSTRUCTION OF PRECONDITIONER
*
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      ELSE
      $DEFAULT=5
      $HELP
        NUMBER OF CORRECTIONS
      $CHECK(MF,DEFAULT,INT,2)
      MX=MIN(NIT-KIT,MF)
      $U='U'
      $UM='UM'
      $AFS=AF
      $AFP=GA
      $ADD(REAL,'\$UM($MF)\$U($NF)')
    $ELSEIF(NOS2=3)
      ELSE
      INF=0
      CALL UXTGGF($N,$D,$DL,$DU,$DU2,$IH,INF)
      IF (INF.NE.0) NOS2=0
      NDECA=NDECA+1
      IDECA=2
    $ENDIF
    ENDIF
  $ELSE
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(JARA='L')
      MX=MIN(NIT-KIT,MF)
    $ENDIF
    $N='NF'
    IF (IDECA.LT.0) IDECA=0
    IF (IDECA.EQ.2) THEN
    ELSE IF (IDECA.NE.0) THEN
    ITERD=-1
    CALL UOERR1('UD$(JARA)GE4',1)
    TDXX='BAD DEC2'
    GO TO $70
*
*     CONSTRUCTION OF PRECONDITIONER
*
    $IF(NOS2=1)
      ELSE
      INF=0
      CALL UXVCOP(MA,$AG,$AG(MA+1))
      CALL UXSGIF($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$IW2,ETA2,INF)
      IF (INF.LT.0) THEN
      ITERD=INF
      TDXX='DEC ERR '
      GO TO $70
      ELSE
      NDECA=NDECA+1
      IDECA=2
      ENDIF
    $ELSEIF(NOS2=2)
      ELSE
      INF=0
      CALL UXSGID($N,MA,$IAG,$JAG,$IB,$IW1,INF)
      IF (INF.LT.0) THEN
      ITERD=INF
      TDXX='DEC ERR '
      GO TO $70
      ENDIF
    $ENDIF
    ENDIF
  $ENDIF
  MOS3=MIN($MOS3,$N)
  $IF(JARA='V')
    CALL UXVCOP($N,$AF,$GN)
    $IF(NOS2=0)
      IF(IREST.NE.0) CALL UYSET3
    $ENDIF
  $ELSEIF(MOS1=1)
    IF (LD.LE.0) THEN
    $IF(JARA='D')
      CALL UXD$(JASB)MM($N,$N,$AG,$AF,$GN)
    $ELSEIF(JARA='S')
      CALL UXSCMM($N,$N,MA,$AG,$IAG,$JAG,$AF,$GN)
    $ELSEIF(JARA='L')
      CALL UXLCMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AF,$GN&
,MET)
    $ENDIF
    ENDIF
  $ELSE
   CALL UXVCOP($N,$AF,$GN)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(JARA='V')
    XDEL=GNORM
  $ELSEIF(MOS1=1)
    $IF(JARA='D')
      CALL UXD$(JASA)MM($N,$N,$AG,$G,$GS)
    $ELSEIF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$G,$GS)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$G&
,$GS,MET)
    $ENDIF
    RHO1=UXVDOT($N,$GS,$GS)
    RHO2=GNORM*GNORM
    IF (RHO1.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(RHO2/RHO1)*GNORM
    ENDIF
  $ELSE
    XDEL=GNORM
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  PAR=SQRT(F/FO)**1.618$P 0
  PAR=MAX(PAR,SQRT(SQRT(TWO*F)))
  PAR=MIN(EPS6,PAR)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,HALF**($DBLE(NIT-LIT)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  RHO2=UXVDOT($N,$AF,$AF)
*
*     PRELIMINARY INEXACT SOLUTION
*
  $IF(JARA='D')
  $ELSEIF(JARA='V')
    CALL UXVCOP($N,$X,$SO)
    CALL UXVCOP($N,$AF,$AFS)
    $IF(MOS2=3)
      IF (MOS2.NE.3) GO TO $11
      CALL UXVNEG($N,$AF,$SN)
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$SN,0)
      SNORM=SQRT(UXVDOT($N,$SN,$SN))
      FO=F
      PP=SQRT(ETA0)/SNORM
      CALL UXVDIR($N,PP,$SN,$SO,$X)
      CALL UYSET2
      ASSIGN $10 TO IMD
      GO TO $LMD
$10   CONTINUE
      IF (F.EQ.FO) THEN
      NOS2=0
      GO TO $11
      ENDIF
      F=FO
      CALL UXVDIF($N,$AF,$AFS,$GS)
      CALL UXVSCL($N,ONE/PP,$GS,$GS)
      CALL UXVSUM($N,$AFS,$GS,$AFO)
      RHO1=UXVDOT($N,$AFO,$AFO)
      IF (RHO1.GT.PAR*RHO2) GO TO $11
      P=UXVDOT($N,$GS,$AFS)
      PP=UXVDOT($N,$GS,$GS)*HALF
      IF (SNORM.LE.XDEL) THEN
      ITERD=2
      TDXX='TLU  REG'
      ELSE
      TEMP=XDEL/SNORM
      CALL UXVSCL($N,TEMP,$SN,$SN)
      SNORM=XDEL
      P=P*TEMP
      PP=PP*TEMP**2
      ITERD=3
      TDXX='TLU  MAX'
      ENDIF
      CALL UXVCOP($N,$SO,$X)
      CALL UXVCOP($N,$AFS,$AF)
      GO TO $70
$11   CONTINUE
    $ENDIF
  $ELSEIF(MOS2=1)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$SN,$XO,0)
    $IF(JARA='S')
      CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
      CALL UXVSUM($N,$AF,$AFO,$AFO)
    $ENDIF
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    IF (SNORM.LE.XDEL) THEN
    ITERD=1
    TDXX='ILU  REG'
    ELSE
    CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='ILU  MAX'
    ENDIF
    GO TO $60
    ENDIF
  $ELSEIF(MOS2=2)
    CALL UXVNEG($N,$AF,$SN)
    CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$SN,$XO,1.0$P 0,0)
    $IF(JARA='S')
      CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
      CALL UXVSUM($N,$AF,$AFO,$AFO)
    $ENDIF
    RHO1=UXVDOT($N,$AFO,$AFO)
    IF (RHO1.LE.PAR*RHO2) THEN
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    IF (SNORM.LE.XDEL) THEN
    ITERD=1
    TDXX='SSOR REG'
    ELSE
    CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='SSOR MAX'
    ENDIF
    GO TO $60
    ENDIF
  $ENDIF
  ITERD=2
*
*     GMRES INITIATION
*
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$GA)
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVCOP($N,$AF,$AFO)
  NRED=0
*
*     GMRES ITERATIONS
*
$20 CONTINUE
  NRED=NRED+1
  IF (NRED.GT.2*$N) GO TO $50
  IF (MOD(NRED,MOS3).EQ.1) THEN
  RHO1=UXVNOR($N,$AFO)
  CALL UXVSCL($N,-ONE/RHO1,$AFO,$AFO)
  CALL UXVSET($N,ZERO,$XS)
  $XS(1)=RHO1
  KRED=0
  ENDIF
  KRED=KRED+1
*
*     GMRES PRECONDITIONING
*
  $IF(JARA='D')
    CALL UXD$(JASA)MM($N,$N,$AG,$AFO((KRED-1)*$N+1),$XO)
  $ELSEIF(JARA='V')
    CALL UXVCOP($N,$AFO((KRED-1)*$N+1),$AFP)
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      CALL UXPRMM($N,MX,$XM,$GM,$JB,$XR,$UM,$U,$GO,$AFP,NOS2)
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$AFP,0)
      ENDIF
    $ENDIF
    PP=SQRT(ETA0/UXVDOT($N,$AFP,$AFP))
    CALL UXVDIR($N,PP,$AFP,$SO,$X)
    FO=F
    CALL UYSET2
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$XO)
    CALL UXVSCL($N,ONE/PP,$XO,$XO)
  $ELSE
    CALL UXVCOP($N,$AFO((KRED-1)*$N+1),$GO)
    $IF(NOS2=1)
      CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$GO,$XO,0)
    $ELSEIF(NOS2=2)
      CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$GO,$XO,1.0$P 0,0)
    $ENDIF
    $IF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$GO,$XO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$GO&
,$XO,MET)
    $ENDIF
  $ENDIF
*
*     THE ARNOLDI BASIS GENERATION USING THE MODIFIED GRAMM-SCHMIDT
*     ORTHOGONALIZATION
*
  DO $31 IRED=1,KRED
  TEMP=UXVDOT($N,$AFO((IRED-1)*$N+1),$XO)
  $GO(IRED)=TEMP
  CALL UXVDIR($N,-TEMP,$AFO((IRED-1)*$N+1),$XO,$XO)
$31 CONTINUE
*
*     APPLY THE PREVIOUS GIVENS ROTATIONS TO THE NEW COLUMN
*     OF THE UPPER HESSENBERG MATRIX
*     (H(1,M), H(2,M),....,H(M+1,M),0,...)^T
*
  DO $32 IRED=1,KRED-1
  CALL UXVROT($GO(IRED),$GO(IRED+1),$GS(IRED),$XP(IRED),0)
$32 CONTINUE
*
*     COMPUTE THE NEW PLANE ROTATION TO ELIMINATE THE NONZERO
*     ELEMENT H(M+1,M) AND OBTAIN R(M,M)
*
  TEMP=UXVNOR($N,$XO)
  IF (TEMP.LE.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)GE4',4)
  GO TO $70
  ENDIF
  IF (KRED.LT.$N) THEN
  $GO(KRED+1)=TEMP
  CALL UXVORT($GO(KRED),$GO(KRED+1),$GS(KRED),$XP(KRED),IER)
  ENDIF
  CALL UXVCOP(KRED,$GO,$AFD(KRED*(KRED-1)/2+1))
*
*     COMPUTE THE NEW BASIS VECTOR V(M+1), APPLY THE NEW PLANE
*     ROTATION TO THE RIGHT HAND SIDE VECTOR ||R0||*E1 AND STORE
*     THE VALUE OF THE COMPUTED ARNOLDI RESIDUAL
*
  IF (KRED.LT.MOS3) CALL UXVSCL($N,ONE/TEMP,$XO,$AFO(KRED*$N+1))
  CALL UXVROT($XS(KRED),$XS(KRED+1),$GS(KRED),$XP(KRED),IER)
  RHO1=ABS($XS(KRED+1))
*
*     COMPUTE THE UNKNOWN VECTOR Y(M) BY THE BACK SUBSTITUTION
*
  CALL UXVCOP(KRED,$XS,$GO)
  CALL UXDPRB(KRED,$AFD,$GO,-1)
  CALL UXVSET($N,ZERO,$XO)
  DO $33 IRED=1,KRED
  CALL UXVDIR($N,$GO(IRED),$AFO((IRED-1)*$N+1),$XO,$XO)
$33 CONTINUE
*
*     GMRES PRECONDITIONING
*
  $IF(JARA='D')
  $ELSEIF(JARA='V')
    $IF(NOS2=0)
    $ELSEIF(NOS2<3)
      CALL UXPRMM($N,MX,$XM,$GM,$JB,$XR,$UM,$U,$GO,$XO,NOS2)
    $ELSEIF(NOS2=3)
      IF (NOS2.EQ.3) THEN
      CALL UXTGGB($N,$D,$DL,$DU,$DU2,$IH,$XO,0)
      ENDIF
    $ENDIF
  $ELSE
    $IF(NOS2=1)
      CALL UXSGIB($N,MA,$AG(MA+1),$IAG,$JAG,$IB,$IW1,$XO,$GO,0)
    $ELSEIF(NOS2=2)
      CALL UXSGIS($N,MA,$AG,$IAG,$JAG,$IB,$IW1,$XO,$GO,1.0$P 0,0)
    $ENDIF
  $ENDIF
  CALL UXVSUM($N,$GA,$XO,$XO)
  TDXX='GMRES MX'
  TEMP=UXVNOR($N,$XO)
  IF (TEMP.GE.XDEL) GO TO $55
  CALL UXVCOP($N,$XO,$SN)
  SNORM=TEMP
  ITERD=2
  TDXX='GMRES ST'
  CALL UOD1D4(RHO2,RHO1**2,PAR,SNORM,XDEL)
  IF (RHO1**2.LE.PAR*RHO2) THEN
  GO TO $60
  ELSE IF (NRED.EQ.2*$N) THEN
  GO TO $50
  ELSE IF (MOD(NRED,MOS3).NE.0) THEN
  GO TO $20
  ENDIF
  $IF(JARA='D')
    CALL UXD$(JASA)MD($N,$N,$AG,$SN,ONE,$AF,$AFO)
  $ELSEIF(JARA='V')
    PP=SQRT(ETA0/UXVDOT($N,$SN,$SN))
    CALL UXVDIR($N,PP,$SN,$SO,$X)
    FO=F
    CALL UYSET2
    ASSIGN $30 TO IMD
    GO TO $LMD
$40 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$AFO)
    CALL UXVSCL($N,ONE/PP,$AFO,$AFO)
    CALL UXVSUM($N,$AF,$AFO,$AFO)
  $ELSE
    $IF(JARA='S')
      CALL UXSRMD($N,$N,MA,$AG,$IAG,$JAG,$SN,ONE,$AF,$AFO)
    $ELSEIF(JARA='L')
      CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$AFO,MET)
      CALL UXVSUM($N,$AF,$AFO,$AFO)
    $ENDIF
  CALL UXVCOP($N,$SN,$GA)
  $ENDIF
  GO TO $20
$50 CONTINUE
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  TDXX='MAX ITER'
  GO TO $60
$55 CONTINUE
*
*     BOUNDARY STEP IS COMPUTED
*
  CALL UXVDIF($N,$XO,$SN,$XO)
  RHO1=UXVDOT($N,$XO,$SN)
  RHO2=UXVDOT($N,$XO,$XO)
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,TEMP)
  CALL UXVDIR($N,TEMP,$XO,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$60 CONTINUE
  $IF(JARA='D')
    CALL UXD$(JASA)MM($N,$N,$AG,$SN,$GS)
  $ELSEIF(JARA='V')
    FO=F
    PP=SQRT(ETA0)/SNORM
    CALL UXVDIR($N,PP,$SN,$SO,$X)
    CALL UYSET2
    ASSIGN $65 TO IMD
    GO TO $LMD
$65 CONTINUE
    F=FO
    CALL UXVDIF($N,$AF,$AFS,$GS)
    CALL UXVSCL($N,ONE/PP,$GS,$GS)
    CALL UXVCOP($N,$SO,$X)
    CALL UXVCOP($N,$AFS,$AF)
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$SN,$GS)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,$N,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$SN&
,$GS,MET)
  $ENDIF
  $IF(JARA='V')
    P=UXVDOT($N,$AF,$GS)
  $ELSEIF(MOS1=1)
    P=UXVDOT($N,$SN,$GN)
  $ELSE
    P=UXVDOT($N,$AF,$GS)
  $ENDIF
  PP=UXVDOT($N,$GS,$GS)*HALF
$70 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(JARA='V')
    CALL UXVCOP($N,$SO,$X)
    CALL UXVCOP($N,$AFS,$AF)
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(JARA)GE4'
  $ENDADD
  $EXIT
