$INTERFACE UDGGG2                                             97/12/01
$REM LU
  $CON1='1.0$P-2'
  $CON2='1.0$P 2'
  $POM1='V'
  $POM2=')'
  $IF(CONSTR='C')
    $IF(HERF='S')
      $POM1='U'
      $POM2=',$$IX,KBF)'
    $ENDIF
  $ENDIF
  $HELP
    NUMBER OF DOG-LEG STEPS
  $CHECK(MOS,5,INT,3)
  $HELP
    CHOICE OF THE FINAL DOG-LEG STEP
      1 - BASIC DOG-LEG STEP
      2 - MODIFIED DOG-LEG STEP
  $CHECK(MOS3,2,'1\2',3)
  $DEFAULT=2
  $IF(MOS=1) $DEFAULT=1
  $HELP
    LEVEL OF DECOMPOSITION SPARING
  $CHECK(MOS4,DEFAULT,'1\2\3',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($M)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$SO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2')
  CALL UOD1D1
  IF (IDECF.LT.0) THEN
  $IF(HERF='D')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $GSS=GS
      $GS=GO
    $ENDIF
    $ADD(REAL,'\$XS($NF)\$GS($NF)')
    $ADD(REAL,'\UXDSMQ\UXDPGQ')
    $N='N'
    $IF(DEC='M')
      $ADD(REAL,'\$B($M)')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0)
      $ELSE
        $IF(MOS2=1)
          $LET='L'
          $ART=',$IB)'
          $ADD(INTEGER,'\$IB($NF)')
        $ELSE
          $LET='S'
          $ART=')'
        $ENDIF
        $ADD(INTEGER,'\$IH($NF)')
        CALL UXVINP($N,$IH)
      $ENDIF
      $IDECF=0
      IDECF=0
      INF=0
      ENDIF
      $ADD(REAL,'\$B($M)')
      CALL UXDSMC($N,$H,$B)
      $HS=H
      $H=B
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GO)
        CALL UXVCOP($N,$GN,$GS)
        CALL UXVMUL($N,$GO,$GN,$GN,1)
      $ENDIF
      $IF(MOS4=1)
        $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
          RHO1=ETA2
          CALL UXDPGF($N,$H,INF,RHO1,RHO2)
          NDECF=NDECF+1
          IDECF=1
        $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
          RHO1=ETA2
          CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,RHO1,RHO2$ART
          NDECF=NDECF+1
          IDECF=4
        $ENDIF
      $ENDIF
    $ELSEIF(DEC='G')
      $IDECF=1
      IDECF=1
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GO)
        CALL UXVCOP($N,$GN,$GS)
        CALL UXVMUL($N,$GO,$GN,$GN,1)
      $ENDIF
      $IF(MOS4=1)
*
*     GILL-MURRAY DECOMPOSITION
*
        RHO1=ETA2
        CALL UXDPGF($N,$H,INF,RHO1,RHO2)
        NDECF=NDECF+1
        IDECF=1
      $ENDIF
      ELSE IF (IDECF.EQ.1) THEN
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      IDECF=1
    $ELSEIF(DEC='S')
      $HELP
         TYPE OF DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',2)
      $IF(MOS2=1)
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE
        $LET='S'
        $ART=','
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
      $IDECF=4
      IDECF=4
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GO)
        CALL UXVCOP($N,$GN,$GS)
        CALL UXVMUL($N,$GO,$GN,$GN,1)
      $ENDIF
      $IF(MOS4=1)
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        RHO1=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,RHO1,RHO2$ART
        NDECF=NDECF+1
        IDECF=4
      $ENDIF
      ELSE IF (IDECF.EQ.1) THEN
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.4) THEN
      ELSE IF (IDECF.EQ.5) THEN
      CALL UXDSRT($N,$H,$IH)
      IDECF=4
    $ENDIF
  $ELSEIF(HERF='S')
    $N='NF'
    $ADD(REAL,'\$XS($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$PERM($NF)')
    $ADD(INTEGER,'\$WN11($NF+1)\$WN12($NF+1)')
    $ADD(REAL,'\UXSSMQ\UXSPCQ\UXVDEL')
    $ADD(INTEGER,'\MM\NOS')
    $IDECF=1
    IDECF=0
    INF=0
    ENDIF
    MM=$IH($N+1)-1
    IF (IDECF.EQ.0) THEN
    $IF(MOS4=1)
      CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
      IF (ITERM.NE.0) THEN
      TDXX='LACK SPC'
      GO TO $50
      ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
      RHO1=ETA2
      CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS&
,INF,RHO1,RHO2)
      NDECF=NDECF+1
      IDECF=1
    $ENDIF
    ELSE IF (IDECF.EQ.1) THEN
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)G$(DEC)2',1)
  GO TO $50
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (IDECF.EQ.0) THEN
  $IF(HERF='D')
    RHO1=UXDSMQ($N,$H,$GN,$GN)
    ELSE
    CALL UXVCOP($N,$GN,$SO)
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$SO,1)
        RHO1=UXDPGQ($N,$H,$SO,$SO)
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$SO,1)
        RHO1=UXDPGQ($N,$H,$SO,$SO)
      $ENDIF
    $ELSEIF(DEC='G')
      CALL UXDPGM($N,$H,$SO,1)
      RHO1=UXDPGQ($N,$H,$SO,$SO)
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GM($N,$H,$IH,$SO,1)
      RHO1=UXDPGQ($N,$H,$SO,$SO)
    $ENDIF
  $ELSEIF(HERF='S')
    RHO1=UXSSMQ($N,MMAX,$H,$IH,$JH,$GN,$GN)
    ELSE
    CALL UX$(POM1)COP($N,$GN,$SO$POM2
    CALL UXVSFP($N,$PERM,$SO,$XS)
    CALL UXSPCM($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SO,$XS,1)
    RHO1=UXSPCQ($N,MMAX-MM,$H(MM+1),$PSL,$SO)
  $ENDIF
  ENDIF
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  CALL UXVNEG($N,$GN,$SO)
  IF (IDECF.NE.0) THEN
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
  $IF(HERF='D')
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGB($N,$H,$SO,0)
      $ELSE
      CALL UXD$(LET)GB($N,$H,$IH,$SO,0)
      $ENDIF
    $ELSEIF(DEC='G')
      CALL UXDPGB($N,$H,$SO,0)
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GB($N,$H,$IH,$SO,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$SO,$XS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SO,0)
    CALL UXVSBP($N,$PERM,$SO,$XS)
  $ENDIF
  ALF=SQRT(UX$(POM1)DOT($N,$SO,$SO$POM2)
  IF (ALF.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UX$(POM1)COP($N,$SO,$SN$POM2
  SNORM=ALF
  ITERD=1
  TDXX='DOG STEP'
  GO TO $40
  ENDIF
  ENDIF
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UX$(POM1)NEG($N,$GN,$XS$POM2
  CALL UX$(POM1)NEG($N,$GN,$XO$POM2
  RHO1=UX$(POM1)DOT($N,$XS,$XS$POM2
  RHO=RHO1
  NOS=MIN($MOS,$N)
  DO $10 NRED=1,NOS
  $IF(HERF='D')
    $IF(DEC='M')
      CALL UXDSMM($N,$H,$XO,$GO)
    $ELSEIF(DEC='G')
      IF (IDECF.EQ.0) THEN
      CALL UXDSMM($N,$H,$XO,$GO)
      ELSE
      CALL UXVCOP($N,$XO,$GO)
      CALL UXDPGM($N,$H,$GO,0)
      ENDIF
    $ELSEIF(DEC='S')
      IF (IDECF.EQ.0) THEN
      CALL UXDSMM($N,$H,$XO,$GO)
      ELSE
      CALL UXVCOP($N,$XO,$GO
      CALL UXD$(LET)GM($N,$H,$IH,$GO,0)
      ENDIF
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XO,$GO)
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XO,$GO$POM2
  TDXX='CG MAX1'
  IF (ALF.LE.ZERO) GO TO $30
  ALF=RHO/ALF
  TDXX='CG MAX2'
  RHO2=SQRT(UX$(POM1)DEL($N,ALF,$XO,$SN$POM2)
  IF (RHO2.GE.XDEL) GO TO $30
*
*     CG STEP
*
  TDXX='CG STEP'
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  SNORM=RHO2
  RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
  CALL UOD1D4(RHO1,RHO2,ALF,SNORM,XDEL)
  IF (RHO2.LE.$CON1*ETA0*RHO1) THEN
  ITERD=1
  GO TO $40
  ELSE IF (RHO2.LE.ETA0*RHO1) THEN
  $IF(MOS4=3)
    ITERD=1
    GO TO $40
  $ELSE
    TDXX='DOG MAX2'
    GO TO $20
  $ENDIF
  ELSE IF (RHO2.LE.$CON2*ETA0*RHO1) THEN
  TDXX='DOG MAX2'
  GO TO $20
  ENDIF
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR($N,ALF,$XO,$XS,$XO$POM2
  RHO=RHO2
$10 CONTINUE
  TDXX='DOG MAX1'
$20  CONTINUE
  IF (IDECF.EQ.0) THEN
  $IF(HERF='D')
    $IF(DEC='M')
      $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
        RHO1=ETA2
        CALL UXDPGF($N,$H,INF,RHO1,RHO2)
        NDECF=NDECF+1
        IDECF=1
        CALL UXDPGB($N,$H,$SO,0)
      $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        RHO1=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,RHO1,RHO2$ART
        NDECF=NDECF+1
        IDECF=4
        CALL UXD$(LET)GB($N,$H,$IH,$SO,0)
      $ENDIF
    $ELSEIF(DEC='G')
*
*     GILL-MURRAY DECOMPOSITION
*
      RHO1=ETA2
      CALL UXDPGF($N,$H,INF,RHO1,RHO2)
      NDECF=NDECF+1
      IDECF=1
      CALL UXDPGB($N,$H,$SO,0)
    $ELSEIF(DEC='S')
      RHO1=ETA2
      CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,RHO1,RHO2$ART
      $ENDIF
      NDECF=NDECF+1
      IDECF=4
      CALL UXD$(LET)GB($N,$H,$IH,$SO,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $50
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    RHO1=ETA2
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS,INF&
,RHO1,RHO2)
    NDECF=NDECF+1
    IDECF=1
    CALL UXVSFP($N,$PERM,$SO,$XS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SO,0)
    CALL UXVSBP($N,$PERM,$SO,$XS)
  $ENDIF
  ALF=SQRT(UX$(POM1)DOT($N,$SO,$SO$POM2)
  IF (ALF.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UX$(POM1)COP($N,$SO,$SN$POM2
  SNORM=ALF
  ITERD=1
  TDXX='DOG STEP'
  GO TO $40
  ENDIF
  ENDIF
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  $IF(MOS3=2)
    ALF=UX$(POM1)DOT($N,$SN,$GO$POM2
    RHO=UX$(POM1)DOT($N,$SO,$GO$POM2
    IF (RHO.EQ.ZERO) THEN
    ALF=ONE
    ELSE
    ALF=MIN(ONE,ALF/RHO)
    ENDIF
    RHO=SQRT(UX$(POM1)DOT($N,$SO,$SO$POM2)
    CALL UXVSCL($N,MAX(ALF,XDEL/RHO),$SO,$SO)
  $ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  CALL UX$(POM1)DIF($N,$SO,$SN,$XO$POM2
*
*     BOUNDARY STEP IS COMPUTED
*
$30 CONTINUE
  RHO1=UX$(POM1)DOT($N,$XO,$SN$POM2
  RHO2=UX$(POM1)DOT($N,$XO,$XO$POM2
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
  CALL UOD1D4(RHO1,RHO2,ALF,SNORM,XDEL)
$40 CONTINUE
  IF(IDECF.EQ.0) THEN
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
    ELSE
    CALL UXVCOP($N,$SN,$GO)
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ENDIF
      $H=HS
    $ELSEIF(DEC='G')
      CALL UXDPGM($N,$H,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
    $ENDIF
  $ELSEIF(HERF='S')
    IF (MOT2.EQ.0) THEN
    PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
    ENDIF
    ELSE
    IF (MOT2.EQ.0) THEN
    CALL UX$(POM1)COP($N,$SN,$GO$POM2
    CALL UXVSFP($N,$PERM,$GO,$XS)
    CALL UXSPCM($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GO,$XS,1)
    PP=UXSPCQ($N,MMAX-MM,$H(MM+1),$PSL,$GO)*HALF
    ENDIF
    IF (ITERD.EQ.1.AND.INF.NE.0) ITERD=2
  $ENDIF
  ENDIF
$50 CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(DEC='M')
      IDECF=0
    $ENDIF
    $IF(MOS1=0)
      $GS=GSS
    $ENDIF
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)G$(DEC)2'
  $ENDADD
  $EXIT
