$INTERFACE UDGRM7                                             11/12/01
$REM LU
  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $CON1='1.0$P-8'
  $CON2='1.0$P-3'
  $CON4='1.0$P-6'
  $POM1='V'
  $POM2=')'
  $IF(CONSTR='C')
    $IF(HERF='S')
      $POM1='U'
      $POM2=',$$IX,KBF)'
    $ENDIF
  $ENDIF
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    CHOICE OF THE SCALING MATRIX:
      1 - COMPLETE LINEARIZATION (NEWTON METHOD)
      2 - PARTIAL LINEARIZATION
  $CHECK(MOS3,1,'1\2',4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'1.0$P-4',REAL,4)
  $HELP
    LOWER PRECISION FOR THE OPTIMUM DIRECTIONAL VECTOR
  $CHECK(DEL1,'0.95$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR THE OPTIMUM DIRECTIONAL VECTOR
  $CHECK(DEL2,'1.10$P 0',REAL,4)
  $HELP
    REGULARIZATION PARAMETER
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\TAU\PPP\DL\DU')
  $IDECF=0
  CALL UOD1D1
  IF (IDECF.LT.0) IDECF=0
  IF (IDECF.NE.0) THEN
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)RM7',1)
  GO TO $50
  ENDIF
  $IF(HERF='D')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $GOS=GO
      $GO=GN
      $GSS=GS
      $GS=GN
    $ENDIF
    $ADD(REAL,'\$H($M)\$B($M)\$GN($NF)\$SN($NF)\$XO($NF)\$GS($NF)')
    $ADD(REAL,'\UXDSDL\UXDPGP\UXDSMQ')
    $HELP
       TYPE OF DECOMPOSITION
         0 - GILL-MURRAY DECOMPOSITION
         1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
         2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,0,'0\1\2',2)
    $IF(MOS2=0)
    $ELSE
      $IF(MOS2=1)
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
    $ENDIF
    $N='N'
    $IF(MOS1>0)
      IF (IDIR.EQ.0) CALL UXDSMX($N,$H,$GS)
      CALL UXVCOP($N,$GN,$GO)
      CALL UXVMUL($N,$GS,$GO,$GO,1)
    $ENDIF
  $ELSEIF(HERF='S')
    $GSS=GS
    $GS=GO
    $GOS=GO
    $GO=GN
    $ADD(REAL,'\$H($MMAX)\$GN($NF)\$SN($NF)\$XO($NF)\$GS($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$WN11($NF+1)')
    $ADD(INTEGER,'\$WN12($NF+1)\$PERM($NF)\MM')
    $ADD(REAL,'\UXSSDL\UXSPCP\UXSSMQ')
    $N='NF'
    MM=$IH($N+1)-1
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GO,$GO$POM2)
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL REGULARIZATION PARAMETER
*
  XDEL=ONE
  ENDIF
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON2) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
    IF (NIT-LIT.GE.$N) PAR=MIN(PAR,$CON4)
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
*
*     INITIAL BOUNDS FOR THE PARAMETER T
*
  NRED=0
  T=ZERO
  $IF(HERF='D')
    E=-UXDSDL($N,$H,INF)
    CALL UXDSMG($N,$H,EL,EU)
  $ELSEIF(HERF='S')
    E=-UXSSDL($N,MMAX,$H,$IH,$JH,INF)
    CALL UXSSMG($N,MMAX,$H,$IH,$JH,EL,EU,$SN)
  $ENDIF
  TL=HALF*(SQRT(EU**2+FOUR*XDEL*GNORM)-EU)
  TU=HALF*(SQRT(EL**2+FOUR*XDEL*GNORM)-EL)
  TL=MAX(TL,ZERO,E)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TDXX='INITIAL '
$20 CONTINUE
  TL=MAX(TL,E)
  IF (T.LE.E.AND.NRED.NE.0) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
  T=MAX(T,TL+$C1L*(TU-TL))
  T=MIN(T,TL+$C1U*(TU-TL))
  TDXX='SHIFTED '
  ENDIF
  ALF=ETA2
  $IF(HERF='D')
    CALL UXDSMC($N,$H,$B)
    CALL UXDSDA($N,$B,T)
    $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
      CALL UXDPGF($N,$B,INF,ALF,RHO)
    $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      CALL UXD$(LET)GF($N,$B,$IH,$SN,INF,ALF,RHO$ART
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $50
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCA($N,MM,MH,MMAX,$H,$IH,$JH,T)
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GS,INF&
,ALF,RHO)
  $ENDIF
  NDECF=NDECF+1
  IF (INF.GT.0) THEN
*
*     NEW ESTIMATION E IS COMPUTED (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  IF (E.GE.TU) THEN
  ITERD=-2
  TDXX='ZERO INT'
  CALL UOERR1('UDGRM7',2)
  GO TO $50
  ELSE
  MODE=2
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGD($N,$B,$SN,INF)
    $ELSE
      CALL UXD$(LET)GD($N,$B,$IH,$SN,INF)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCD($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,INF)
    CALL UXVSBP($N,$PERM,$SN,$GS)
  $ENDIF
  E=MAX(E,T-ALF/UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=NRED+1
  GO TO $20
  ENDIF
  ELSE
*
*     STEP S IS COMPUTED
*
  CALL UX$(POM1)NEG($N,$GO,$SN$POM2
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGB($N,$B,$SN,0)
    $ELSE
      CALL UXD$(LET)GB($N,$B,$IH,$SN,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$SN,$GS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),PSL,JH(MM+1),$SN,0)
    CALL UXVSBP($N,$PERM,$SN,$GS)
  $ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  PPP=T/XDEL
  MODE=1
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  ENDIF
  IF (TU-TL.LE.$CON1) THEN
*
*     INTERVAL IS TOO SMALL
*
  IF (T.NE.ZERO) THEN
  ITERD=5
  TDXX='ZERO INT'
  ELSE
  ITERD=1
  TDXX='OLC STEP'
  ENDIF
  GO TO $40
  ELSE IF (NRED.GE.20) THEN
*
*     MAXIMUM NUMBER OF OLC REDUCTIONS
*
  ITERD=6
  TDXX='MAX NRED'
  GO TO $40
  ELSE IF (ABS(SNORM-PPP)*SNORM*XDEL.LE.PAR*GNORM) THEN
*
*     SOLUTION WITH A GIVEN PRECISION
*
  ITERD=4
  TDXX='INEXACT '
  GO TO $40
  ELSE IF (SNORM.GT.DEL2*PPP) THEN
*
*     STEP IS TOO LARGE
*
  TL=MAX(TL,T)
  GO TO $30
  ELSE IF (SNORM.LT.DEL1*PPP) THEN
  IF (T.NE.ZERO) THEN
*
*     STEP IS TOO SMALL
*
  TU=MIN(TU,T)
  ELSE
*
*     STEP IS ACCEPTABLE
*
  ITERD=1
  TDXX='OLC STEP'
  GO TO $40
  ENDIF
  ELSE
  ITERD=3
  TDXX='OLC MAX1'
  GO TO $40
  ENDIF
  IF ((T-TL)/T.GT.(ONE-DEL1**2)/(TWO*DEL1**2)) GO TO $30
*
*     TRYING TO COMPUTE STEP IN THE SINGULAR CASE
*
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGN($N,$B,$XO,RHO,1)
    $ELSE
      CALL UXD$(LET)GN($N,$B,$IH,$XO,RHO,1)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCN($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,RHO,1)
    CALL UXVSBP($N,$PERM,$XO,$GS)
  $ENDIF
  RHO1=UX$(POM1)DOT($N,$XO,$SN$POM2
  RHO2=UX$(POM1)DOT($N,$XO,$XO$POM2
  CALL UNSTEP(PPP,SNORM,ABS(RHO1),RHO2,ALF)
  IF (ALF*ALF*RHO.LE.(DEL1*DEL1-ONE)*UX$(POM1)DOT($N,$GO,$SN$POM2) THEN
  IF (RHO1.LT.ZERO) ALF=-ALF
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  SNORM=PPP
  ITERD=3
  TDXX='OLC MAX2'
  GO TO $40
  ELSE
  E=MAX(E,T-RHO)
  ENDIF
$30 CONTINUE
  IF (GNORM.LE.ZERO) THEN
  T=E
  ELSE
*
*     NEW T IS COMPUTED USING ONE STEP OF THE NEWTON METHOD FOR
*     NONLINEAR EQUATION
*
  CALL UX$(POM1)COP($N,$SN,$XO$POM2
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGB($N,$B,$XO,1)
      TAU=T*PPP*UXDPGP($N,$B,$XO,$XO)/(SNORM*SNORM)
    $ELSE
      CALL UXD$(LET)GB($N,$B,$IH,$XO,1)
      TAU=T*PPP*UXDPGP($N,$B,$XO,$XO)/(SNORM*SNORM)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$XO,$GS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,1)
    TAU=T*PPP*UXSPCP($N,MMAX-MM,$H(MM+1),$PSL,$XO)/(SNORM*SNORM)
    CALL UXVSBP($N,$PERM,$XO,$GS)
  $ENDIF
  IF (MOS3.EQ.1.OR.PPP.GT.SNORM) THEN
  T=T+T*(SNORM-PPP)/(SNORM+TAU)
  ELSE
  T=T+TWO*T*(SNORM-PPP)/(PPP+TAU+SQRT((PPP-TAU)**2+FOUR*TAU&
*SNORM))
  ENDIF
  TDXX='NEWTON  '
  ENDIF
  NRED=NRED+1
  GO TO $20
$40 CONTINUE
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
    $IF(MOS1>0)
      CALL UXVMUL($N,$GS,$SN,$SN,1)
    $ENDIF
  $ELSEIF(HERF='S')
    IF (MOT2.EQ.0) THEN
    PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
    ENDIF
  $ENDIF
  PPP=XDEL*SNORM**3/THREE
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(MOS1=0)
      $GO=GOS
      $GS=GSS
    $ENDIF
  $ELSEIF(HERF='S')
    $GO=GOS
    $GS=GSS
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)GM7'
  $ENDADD
  $EXIT
