$INTERFACE US1L01                                             97/12/01
  $HELP
    METHOD OF LINE SEARCH:
      1 - BISECTION
      2 - QUADRATIC INTERPOLATION
          (WITH ONE DIRECTIONAL DERIVATE)
      3 - QUADRATIC INTERPOLATION
          (WITH TWO DIRECTIONAL DERIVATES)
      4 - CUBIC INTERPOLATION
      5 - HOMOGENEOUS INTERPOLATION
      6 - CONIC INTERPOLATION
  $CHECK(MES,4,'1\2\3\4\5\6',3)
  $HELP
    SWITCH FOR EXTRAPOLATION:
      1 - CONSTANT INCREASING OF THE INTERVAL
      2 - EXTRAPOLATION SPECIFIED BY THE PARAMETER MES
      3 - SUPPRESSED EXTRAPOLATION
  $CHECK(MES1,2,'1\2\3',4)
  $HELP
    SWITCH FOR TERMINATION OF LINE SEARCH:
      1 - NORMAL TERMINATION
      2 - SPECIAL TERMINATION FOR NONCONVEX FUNCTIONS
      3 - TERMINATION AFTER AT LEAST TWO STEPS
          (ASYMPTOTICALLY PERFECT LINE SEARCH)
  $CHECK(MES2,2,'1\2\3',4)
  $HELP
    SAFEGUARD AGAINST ROUNDING ERRORS:
      0 - SAFEGUARD SUPPRESSED
      1 - FIRST LEVEL OF SAFEGUARD
      2 - SECOND LEVEL OF SAFEGUARD
      3 - HAGER-ZHANG SAFEGUARD
  $CHECK(MES3,2,'0\1\2\3',4)
  $HELP
    UPPER BOUND FOR FUNCTION VALUE
  $CHECK(FMAX,'1.0$P 20',REAL,4)
  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,'1.0$P 2*ETA0',REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
  $CHECK(EPS1,'1.0$P-4',REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'0.9$P 0',REAL,4)
  $IF(NONMONOTONE=0)
  $ELSE
    $HELP
      PARAMETER FOR NONMONOTONE SEARCH (ZERO.LE.EPS5.LE.ONE)
    $CHECK(EPS5,'0.5$P 0',REAL,4)
  $ENDIF
  $HELP
    MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
  $CHECK(MRED,10,INT,4)
  CALL US1L01(EPS1,EPS2,EPS5,$ETA1,RO,RP,R,FO,FP,F,PO,PP,P,FMIN,FMAX&
,PAR1,PAR2,RMAX,RMIN,GNORM,SNORM,MODE,KTERS,MES,MES1,MES2,MES3,INITS&
,MRED,$KDS,$NONMONOTONE)
$REM  $ADD(REAL,'\EPS1\EPS2\EPS5\RO\RP\R\FO\FP\F\PO\PP\P\FMIN\FMAX&
$REM  \PAR1\PAR2\RMAX\RMIN\GNORM\SNORM')
$REM  $ADD(INTEGER,'\MODE\KTERS\MES\MES1\MES2\MES3\INITS\MRED')
  $ADD(INIT)
    NSXX='US1L01'
  $ENDADD
  $EXIT
