$INTERFACE UUDCI1                                             11/12/01
$REM LU
  $CON0='0.1$P 0'
  $CON1='1.0$P 0'
  $CON2='1.0$P 1'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='5.0$P-8'
  $CON6='1.0$P-4'
  $CON7='1.0$P-6'
  $GAML='1.0$P 0'
  $GAMU='6.0$P 0'
  $IF($DEF(MOS5))
  $ELSE
    $MOS5=0
  $ENDIF
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,3,'-2\-1\1\2',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $DEFAULT=1
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
      4 - HARMONIC MEAN
      5 - ARITHMETIC MEAN
  $CHECK(MET4,DEFAULT,'1\2\3\4\5',4)
  $SNORM=0
  $IF(MET=10) $SNORM=1
  $N='N'
  $IF(CLASS='VR') $N='NN'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $POM4='($N,$H,$S,$XO,$GO,R,PO'
  $POM6='(N,H,S,XO,GO,R,PO'
  $ADD(POM4,',$XS,$GS,$XP,$GP')
  $ADD(POM6,',XS,GS,XP,GP')
  $ADD(REAL,'\$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)')
  $IF(MET2<0)
    $ADD(POM4,',$GN')
    $ADD(POM6,',G')
  $ENDIF
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
  $IF(NET2>1)
    $ADD(POM4,',F,FO,P')
    $ADD(POM6,',F,FO,P')
  $ELSEIF(MET5>0)
    $ADD(POM4,',P')
    $ADD(POM6,',P')
  $ENDIF
  $IF(MET5>0)
    $ADD(POM4,',GNORM')
    $ADD(POM6,',GNORM')
  $ENDIF
  $IF(SNORM=1)
    $ADD(POM4,',SNORM')
    $ADD(POM6,',SNORM')
  $ENDIF
  $IF(MOS5=0)
    $ADD(REAL,'\GAM')
    $ADD(POM4,',ETA9,MET,GAM)')
    $ADD(POM6,',ETA9,MET,GAM)')
  $ELSE
    $ADD(REAL,'\GAM\RHO\AUPD\BUPD\CUPD\ETA')
    $ADD(POM4,',ETA9,MET,GAM,RHO,AUPD,BUPD,CUPD,ETA)')
    $ADD(POM6,',ETA9,MET,GAM,RHO,A,B,C,ETA)')
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDCI1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDCI1
*     ----------------------------------------
  SUBROUTINE UUDCI1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$FLOAT H(N*(N+1)/2),S(N),XO(N),GO(N),R,PO,ETA9
  $$IF($MET=12) $$FLOAT XS(N),GS(N)
  $$IF($MET2<0) $$FLOAT G(N)
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$IF($NET2>1)
    $$FLOAT F,FO,P
  $$ELSEIF($MET5>0)
    $$FLOAT P
  $$ENDIF
  $$IF($MET5>0) $$FLOAT GNORM
  $$IF($SNORM=1) $$FLOAT SNORM
  $$FLOAT AA,CC
  COMMON /UMFUN1/ AA,CC
  $$FLOAT UXVDOT,UNFUN1
  $$FLOAT DIS,ETA,A,B,C,GAM,RHO,PAR
  $$IF($MET>2) $$FLOAT DEN
  $$IF($MET5>0) $$FLOAT TAU
  INTEGER IUPDT
  LOGICAL L1,L3
  $$IF ($NET1=3) LOGICAL L2
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ELSEIF($NET2>1)
    $$FLOAT POM1,POM2
  $$ENDIF
  $$IF($MET1=6) $$FLOAT BS,CS,DS,DEL
  $$IF($MET2<0) $$FLOAT TEMP
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDCI1',1)
  GO TO 22
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  $$IF($MET3=2)
  $$ELSE
    IF (B.LE.ZERO) THEN
    ITERH=2
    TUXX='B - NEG.'
    GO TO 22
    ENDIF
  $$ENDIF
  CALL UXDSMM(N,H,GO,S)
  A=UXVDOT(N,GO,S)
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  C=ZERO
  IF(MET.GE.4.OR.L1) THEN
  IF (ITERD.EQ.1) THEN
  C=-R*PO
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  ENDIF
  ENDIF
  $$IF($MET3=2)
    IF(B.LE.ZERO) THEN
*
*     POWELL'S CORRECTION
*
    DIS=(ONE-$CON0)*A/(A-B)
    CALL UXVDIF(N,XO,S,XO)
    CALL UXVDIR(N,DIS,XO,S,XO)
    B=A+DIS*(B-A)
    IF (MET.GE.4.OR.L1) C=A+TWO*(ONE-DIS)*(B-A)+DIS*DIS*(C-A)
    ENDIF
  $$ENDIF
*
*     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
*
  $$IF($NET2=1)
    RHO=ONE
  $$ELSEIF($NET2<5)
    IF (PO.EQ.ZERO) THEN
    RHO=ONE
    ELSE
    POM1=(F-FO)/PO
    POM2=P/PO
    $$IF($NET2=2)
      IF (POM1.EQ.POM2.OR.POM2.EQ.ONE) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(POM2-POM1)
      ENDIF
    $$ELSEIF($NET2=3)
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $$ELSEIF($NET2=4)
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $ENDIF
    IF(RHO.LE.$CON4) RHO=ONE
    IF(RHO*$CON4.GE.ONE) RHO=ONE
    ENDIF
  $$ELSE
    RHO=ONE
  $$ENDIF
  AA=A/B
  CC=C/B
  IUPDT=0
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  IF (C.LE.ZERO) THEN
  PAR=A/B
  ELSE
  $$IF($NET1=6)
    MET4=0
    DEL=SQRT(UXVDOT(N,XO,XO))
    IF (NIT.EQ.KIT) THEN
    PAR=B/C
    ELSE
    PAR=(BS/DS+B/DEL)/(BS/DS+C/DEL)
    ENDIF
  $$ENDIF
  $$IF(MET4=1)
    PAR=A/B
  $$ELSEIF(MET4=2)
    PAR=B/C
  $$ELSEIF(MET4=3)
    PAR=SQRT(A/C)
  $$ELSEIF(MET4=4)
    PAR=TWO*(A/C)/(A/B+B/C)
  $$ELSEIF(MET4=5)
    PAR=HALF*(A/B+B/C)
  $$ENDIF
  ENDIF
  GAM=RHO/PAR
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    GAM=MAX(GAM,$CON6)
    GAM=MIN(GAM,ONE/$CON6)
    PAR=RHO/GAM
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$GAML
    L3=L3.OR.GAM.GT.$GAMU
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$GAML.OR.GAM.GT.$GAMU
    ENDIF
  $$ELSEIF($NET1=6)
    IF (NIT.NE.KIT) THEN
    GAM=MIN(GAM,$CON2)
    L3=GAM.LE.$CON1
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  GAM=ONE
  PAR=RHO/GAM
  ENDIF
  $$U17=0
  $$U18=0
  $$U19=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    ETA=ZERO
    CALL UXDSMU(N,H,PAR/B,XO)
    CALL UXDSMU(N,H,-ONE/A,S)
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=PAR*B+A
    DIS=HALF*B
    ETA=PAR*B/DEN
    CALL UXVDIR(N,PAR,XO,S,GO)
    CALL UXDSMU(N,H,PAR/DIS,XO)
    CALL UXDSMU(N,H,-ONE/DEN,GO)
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    $$U18=1
    IF (C.LE.ZERO) GO TO 17
    DEN=PAR*B-A
    DIS=PAR*C-B
    IF (DEN.LE.1.0$P-8*A) GO TO 17
    IF (DEN.GT.ZERO.OR.DIS.LT.ZERO) GO TO 18
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    $$U17=1
    $$U18=1
    $$U19=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=PAR*B-A
    DIS=PAR*C-B
    IF (PAR*C*DEN.LE.A*DIS) GO TO 19
    IF (DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=6)
*
*     SIMPLE PRECONVEX UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    ETA=ONE+ONE/SQRT(MAX(ONE/$ETA9,ONE-ONE/(AA*CC)))
    TUXX='LUKSAN 1'
    NUPD=NUPD+1
    GO TO 20
  $$ELSEIF($MET=7)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    ETA=TWO
    DIS=TWO*AA
    CALL UXVDIR(N,-DIS,XO,S,GO)
    CALL UXDSMU(N,H,ONE/A,GO)
    CALL UXDSMU(N,H,(PAR-DIS)/B,XO)
    TUXX='LUKSAN 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=8)
*
*     NEW UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    ETA=ONE/(AA*CC)
    IF (ETA.LT.ONE) THEN
    ETA=MAX(1.0$P-15,(SQRT(C/A)-ETA)/(ONE-ETA))
$REM    DEN=MAX(ETA+$ETA0,SQRT(C/A))
$REM    ETA=(DEN-ETA)/(ONE-ETA)
$REM    ETA=(DEN-ETA)/MAX(ONE/$ETA9,ONE-ETA)
$REM    ETA=MAX(ZERO,SQRT(C/A)-ETA)/MAX(ONE/$ETA9,ONE-ETA)
    TUXX='NEW     '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSEIF($MET=9)
*
*     TEWARSON-1 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    POM1=SQRT(ONE/CC)
    POM2=SQRT(AA)
    NRED=20
    CALL UNNEQ1(POM1,POM2,DIS,DEN,UNFUN1,$CON5,$ETA0,NRED,MODE)
    IF (MODE.GE.0) THEN
    ETA=ONE/(AA*CC)
    DEN=MAX(ETA+$ETA0,CC*DIS**2)
    ETA=(DEN-ETA)/MAX(ONE/$ETA9,ONE-ETA)
    TUXX='TEWARS 1'
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSEIF($MET=10)
*
*     TEWARSON-2 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM1=ONE-ONE/(R*AA)
    POM2=ONE-CC/R
    DEN=POM1*DEN-POM2*DIS/AA
    DIS=POM1*DIS-POM2*UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    ETA=TWO*DIS
    ELSE
    ETA=POM2/POM1
    IF(ETA.GT.ZERO) THEN
    ETA=R*PAR*DEN*ETA
    ETA=MAX(DIS,MIN(TWO*DIS,ETA))
    ELSE
    ETA=TWO*DIS
    ENDIF
    ENDIF
    ETA=(ETA-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    TUXX='TEWARS 2'
    NUPD=NUPD+1
    GO TO 20
  $$ELSEIF($MET=11)
*
*     TEWARSON-3 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM2=ONE-CC/R
    DEN=DEN-DIS/AA
    DIS=DIS-UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    ETA=TWO*DIS
    ELSE
    ETA=POM2/POM1
    ETA=R*PAR*DEN*ETA
    ETA=MAX(DIS,MIN(TWO*DIS,ETA))
    ENDIF
    ETA=(ETA-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    TUXX='TEWARS 3'
    NUPD=NUPD+1
    GO TO 20
  $$ELSEIF($MET=12)
*
*     LPD UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    IF (NIT.EQ.KIT+1) THEN
    DEN=UXVDOT(N,GO,XS)
    IF (DEN.EQ.0) THEN
    ETA=ZERO
    ELSE
    ETA=UXVDOT(N,XO,GS)/DEN
    ENDIF
    DEN=ONE-AA*ETA
    IF (DEN.GT.ZERO) THEN
    ETA=ONE/DEN
    TUXX='LPD     '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
    ENDIF
  $$ELSEIF($MET=13)
*
*     DUAL PRODUCT UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DIS=B*(B+PAR*C)
    DEN=DIS-A*C
    IF (DEN.GT.ZERO) THEN
    ETA=DIS/DEN
    TUXX='VLCEK   '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSE
    $$U20=1
    ETA=1.0$P 0
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    ETA=ONE
    DIS=PAR+AA
    CALL UXVDIR(N,-DIS,XO,S,GO)
    DIS=ONE/(B*DIS)
    CALL UXDSMU(N,H,DIS,GO)
    CALL UXDSMU(N,H,-DIS,S)
    TUXX='BFGS    '
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    ETA=PAR*B/DEN
    CALL UXVDIR(N,-PAR,XO,S,GO)
    CALL UXDSMU(N,H,ONE/DEN,GO)
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U19>0)
19 CONTINUE
*
*     DAVIDON'S UPDATE
*
    DEN=AA*CC-ONE
    IF (DEN.EQ.ZERO) GO TO 17
    ETA=(PAR*CC-ONE)/DEN
    IF (ETA.LE.ZERO) GO TO 17
    TUXX='DAVIDON '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    DEN=PAR+ETA*AA
    DIS=ETA/DEN
    CALL UXDSMU(N,H,(PAR*DIS-ONE)/A,S)
    CALL UXVDIR(N,-DIS,S,XO,GO)
    CALL UXDSMU(N,H,DEN/B,GO)
  $$ENDIF
21 CONTINUE
  ITERH=0
  IF (GAM.EQ.ONE) GO TO 22
*
*     SCALING
*
  CALL UXDSMS(N,H,GAM)
  NSCL=NSCL+1
22 CONTINUE
  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,ETA,ETA9)
  $$IF($MET2<0)
    CALL UXDSMM(N,H,G,S)
    ETA=TEMP*SQRT(UXVDOT(N,S,S))/UXVDOT(N,G,G)
    CALL UXDSMU(N,H,ETA,G)
  $$ENDIF
  $$IF($MET=12)
    CALL UXVCOP(N,XO,XS)
    CALL UXVCOP(N,GO,GS)
  $$ENDIF
  $$IF($NET1=6)
    BS=B
    CS=C
    DS=DEL
  $$ENDIF
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDCI1'
  $ENDADD
  $EXIT
