$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZINIT                                    01/12/89  +
$REM + SI                                                            +
$REM + PURPOSE:  INITIATION OF METHOD                                +
$REM +---------------------------------------------------------------+

$NEWRUN=.FALSE.
$NEWMODEL=.FALSE.
$NMET='$DATA(NUMBERS)'
$IF($DEF(LMET))
  $IF(LMET<0)
    $NEWRUN=.TRUE.
    $LMET=NMET
  $ENDIF
$ELSE
  $NEWRUN=.TRUE.
  $NEWMODEL=.TRUE.
  $SUBST('UZARRY')
  $KDF=-1
  $KDA=-1
  $KDC=-1
  $KDE=-1
  $KDY=-1
  $SET(INIT)
  *
  *     ---------------------
  *     INITIATION OF PROBLEM
  *     ---------------------
  *
  $ENDSET
  $LMET=NMET
$REM --- AUTOMATIC DIFFERENTIATION ---
  $IF($DEF(IADF))
  $ELSE
    $IADF=0
  $ENDIF
  $IF($DEF(IADA))
  $ELSE
    $IADA=0
  $ENDIF
  $IF($DEF(IADC))
  $ELSE
    $IADC=0
  $ENDIF
$REM --- AD SUBROUTINES ---
  $IF(IADF=2)
    $SUBST('UZADS2')
  $ELSEIF(IADA=2)
    $SUBST('UZADS2')
  $ELSEIF(IADC=2)
    $SUBST('UZADS2')
  $ELSEIF(IADF=1)
    $SUBST('UZADS1')
  $ELSEIF(IADA=1)
    $SUBST('UZADS1')
  $ELSEIF(IADC=1)
    $SUBST('UZADS1')
  $ELSE
  $ENDIF
$REM --- AD FOR FMODELF ---
  $IF(IADF=1)
    $SUBST('UZADF1')
  $ENDIF
  $IF(IADF=2)
    $SUBST('UZADF2')
  $ENDIF
$REM --- AD FOR FMODELA ---
  $IF(IADA=1)
    $SUBST('UZADA1')
  $ENDIF
  $IF(IADA=2)
    $SUBST('UZADA2')
  $ENDIF
$REM --- AD FOR FMODELC ---
  $IF(IADC=1)
    $SUBST('UZADC1')
  $ENDIF
  $IF(IADC=2)
    $SUBST('UZADC2')
  $ENDIF
$REM --- CUTE INTERFACE ---
  $IF($DEF(SIF))
    $SUBST('UZSIFD')
  $ENDIF
  $SUBST('UZPROB')
  $IF($DEF(JACA))
    $IF(JACA='S')
      $SETA='CALL $UKMAI1'
    $ELSE
      $SETA='CALL $ULMAI1'
    $ENDIF
  $ENDIF
  $IF($DEF(JACC))
    $IF(JACC='S')
      $SETC='CALL $UKMCI1'
    $ELSE
      $SETC='CALL $ULMCI1'
    $ENDIF
  $ENDIF
  $HELP
    COLLECTION OF TEST PROBLEMS:
      N - COLLECTION IS NOT USED
      Y - COLLECTION WITH BASIC OUTPUT
      E - COLLECTION WITH EXTENDED OUTPUT
      P - COLLECTION WITH PERFORMANCE PROFILES
  $CHECK(COLLECTION,'N','NO\N\YES\Y\EXTENDED\E\PROFILE\P',1,NO)
  $IF(COLLECTION='N') $COLLECTION='NO'
  $IF(COLLECTION='Y') $COLLECTION='YES'
  $IF(COLLECTION='E') $COLLECTION='EXTENDED'
  $IF(COLLECTION='P') $COLLECTION='PROFILE'
  $IF(COLLECTION<>'NO')
    $REPEAT
      $HELP
        NUMBER OF TEST PROBLEMS
      $CHECK(NEXT,0,INT,1)
      $IF(NEXT<=0)
        $IF(DIALOG>0)
          $ERASE(NEXT)
        $ELSE
          $ERROR 'NEXT' - NUMBER OF TEST PROBLEMS WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(NEXT))
    $HELP
       DO LOOP FOR THE COLLECTION OF TEST PROBLEMS:
        N - DO LOOP IN THE CONTROL PROGRAM IS NOT USED
        Y - DO LOOP IN THE CONTROL PROGRAM IS USED
    $CHECK(TESTCYCLE,'N','NO\N\YES\Y',1,NO)
    $IF(TESTCYCLE='N') $TESTCYCLE='NO'
    $IF(TESTCYCLE='Y') $TESTCYCLE='YES'
    $IF(COLLECTION='PROFILE')
      $HELP
        QUANTITY FOR COMPUTING PERFORMANCE PROFILES
          N    - PERFORMANCE PROFILES ARE NOT COMPUTED IMMEDIATELY
          NIT  - NUMBER OF ITERATIONS
          NFV  - NUMBER OF FUNCTION VALUES
          NFG  - NUMBER OF GRADIENTS
          NCGR - NUMBER OF INNER ITERATIONS
          TIME - CPU TIME
      $CHECK(PROFILE,'NO','N\NO\NIT\NFV\NFG\NCGR\TIME',1,NO)
      $IF(PROFILE='N') $PROFILE='NO'
      $IF(PROFILE<>'NO')
        $HELP
          UPPER BOUND FOR PERFORMANCE PROFILES
        $CHECK(BOUND,'2.0$P 0',REAL,1,NO)
      $ENDIF
      $HELP
        FORM OF THE PERFORMANCE DATA 
          PROFDATA='A' - ABSOLUTE DATA (TOTAL NUMBERS)   
          PROFDATA='R' - RELATIVE DATA (NUMBERS PER ITERATION)
      $CHECK(PROFDATA,'ABSOLUTE','ABSOLUTE\A\RELATIVE\R',1,NO)
      $IF(PROFDATA='A') $PROFDATA='ABSOLUTE'
      $IF(PROFDATA='R') $PROFDATA='RELATIVE'
      $HELP
          NUMBER OF REPEATED COMPUTATIONS 
      $CHECK(REPEATED,1,INT,1,NO)
      $IF(REPEATED< 1) $REPEATED=1
      $IF(REPEATED>50) $REPEATED=50
      OPEN(7,FILE='P.PER',STATUS='UNKNOWN',POSITION='APPEND')
    $ENDIF
  $ENDIF
  $IF(COLLECTION<>'NO')
    $ADD(INIT)
      CALL UYTES1(NF,NC,NA,NE)
    $ENDADD
  $ENDIF
  $ADD(INIT)
  *
  *     -----------------
  *     END OF INITIATION
  *     -----------------
  *
  $ENDADD
  $SET(PINIT=INIT)
$ENDIF

$IF(NMET=1)
  $ETA0='1.0$P-15'
  $ETA9='1.0$(P)120'
  $IF(GRAPHICS=0)
    $GRAPH='NO'
  $ELSEIF(GRAPHICS=-1)
    $HELP
      SPECIFICATION OF GRAPHICAL OUTPUT:
        N - GRAPHICAL OUTPUT IS NOT USED
        E - DATA FOR EXTERNAL GRAPHICAL DEVICES ARE GENERATED    
        Y - BASIC (EXTERNAL) CHOICE IS USED
        C - BASIC (EXTERNAL) CHOICE WITH COMPLETE GRAPHICAL 
            SPECIFICATIONS IS USED 
    $CHECK(GRAPH,'N','NO\N\EXTERNAL\E\YES\Y\COMPLETE\C',1,NO)
    $LETTER='J'
  $ELSEIF(GRAPHICS=-2)
    $HELP
      SPECIFICATION OF GRAPHICAL OUTPUT:
        N - GRAPHICAL OUTPUT IS NOT USED
        I - MATLAB INTERNAL GRAPHICAL OUTPUT IS USED    
        E - MATLAB EXTERNAL GRAPHICAL OUTPUT IS USED    
        Y - BASIC (INTERNAL) MATLAB GRAPHICAL OUTPUT IS USED
        C - BASIC (INTERNAL) MATLAB GRAPHICAL OUTPUT WITH COMPLETE 
            GRAPHICAL SPECIFICATIONS IS USED
    $CHECK(GRAPH,'N','NO\N\INTERNAL\I\EXTERNAL\E\YES\Y\COMPLETE\C',1,NO)
    $LETTER='M'
  $ELSEIF(GRAPHICS=-3)
    $HELP
      SPECIFICATION OF GRAPHICAL OUTPUT:
        N - GRAPHICAL OUTPUT IS NOT USED
        I - SCILAB INTERNAL GRAPHICAL OUTPUT IS USED    
        E - SCILAB EXTERNAL GRAPHICAL OUTPUT IS USED    
        Y - BASIC (INTERNAL) SCILAB GRAPHICAL OUTPUT IS USED
        C - BASIC (INTERNAL) SCILAB GRAPHICAL OUTPUT WITH COMPLETE 
            GRAPHICAL SPECIFICATIONS IS USED
    $CHECK(GRAPH,'N','NO\N\INTERNAL\I\EXTERNAL\E\YES\Y\COMPLETE\C',1,NO)
    $LETTER='S'
  $ELSEIF(GRAPHICS>0)
    $HELP
      SPECIFICATION OF GRAPHICAL OUTPUT:
        N - GRAPHICAL OUTPUT IS NOT USED
        I - FORTRAN INTERNAL GRAPHICAL OUTPUT IS USED    
        Y - BASIC (INTERNAL) FORTRAN GRAPHICAL OUTPUT IS USED
        C - BASIC (INTERNAL) FORTRAN GRAPHICAL OUTPUT WITH COMPLETE 
            CHOICES IS USED
    $CHECK(GRAPH,'N','NO\N\INTERNAL\I\EXTERNAL\E\YES\Y\COMPLETE\C',1,NO)
    $LETTER='G'
  $ENDIF
  $IF(GRAPH='N') $GRAPH='NO'
  $IF(GRAPH='I') $GRAPH='INTERNAL'
  $IF(GRAPH='E') $GRAPH='EXTERNAL'
  $IF(GRAPH='Y') $GRAPH='YES'
  $IF(GRAPH='C') $GRAPH='COMPLETE'
  $IF(GRAPH='YES')
    $GRAPH='EXTERNAL'
    $IF(GRAPHICS> 0) $GRAPH='INTERNAL'
    $IF(GRAPHICS<-1) $GRAPH='INTERNAL'
  $ELSEIF(GRAPH='COMPLETE')
    $MAP='YES'
    $ISO='YES'
    $HIL='YES'
    $PATH='YES'
    $GRAPH='EXTERNAL'
    $IF(GRAPHICS> 0) $GRAPH='INTERNAL'
    $IF(GRAPHICS<-1) $GRAPH='INTERNAL'
  $ELSEIF(GRAPH='EXTERNAL')  
    $IF(GRAPHICS> 0) $GRAPH='INTERNAL'
  $ENDIF    
  $IF(GRAPH='NO')
    $HELP
      SPECIFICATION OF EXTENDED SCREEN OUTPUT:
        N - EXTENDED SCREEN OUTPUT SUPPRESSED
        Y - EXTENDED SCREEN OUTPUT REQUIRED
    $CHECK(DISPLAY,'N','NO\N\YES\Y',1,NO)
    $IF(DISPLAY='N') $DISPLAY='NO'
    $IF(DISPLAY='Y') $DISPLAY='YES'
    $PICTURES='NO'
  $ELSE
    $DISPLAY='NO'
  $ENDIF
  $IF(COLLECTION<>'NO')
    $IF(GRAPH='EXTERNAL')
      $GRAPH='NO'
    $ENDIF
  $ENDIF
  
  $SET(UYINTP=' ')
  $LISTUYINT='UYINTP'
  CALL UYCLEA
  OPEN(2,FILE='P.OUT',STATUS='UNKNOWN')
  OPEN(3,FILE='P.DIM',STATUS='UNKNOWN')
  $IF(GRAPH='NO')
  $ELSE
    CALL UYCLEG
    CLOSE(4)
    $IF(GRAPHICS=6)
      $ADD(SUBROUTINES)
        logical*4 function initialsettings()
        use dfwin
        integer*4 hookhandle, primarythreadid
        common hookhandle, primarythreadid
        primarythreadid = GetCurrentThreadId()
        initialsettings = .true.
        end
        SUBROUTINE EMPTY
        USE DFLIB
        CHARACTER*1 CH
        CH=GETCHARQQ()
        RETURN
        END
      $ENDADD
    $ELSEIF(GRAPHICS=8)  
      $ADD(SUBROUTINES)
        logical*4 function initialsettings()
        use dfwin
        integer*4 hookhandle, primarythreadid
        common hookhandle, primarythreadid
        primarythreadid = GetCurrentThreadId()
        initialsettings = .true.
        end
        SUBROUTINE EMPTY
        USE DFLIB
        CHARACTER*1 CH
        CH=GETCHARQQ()
        RETURN
        END
      $ENDADD
    $ENDIF
  $ENDIF
  $SET(END)
    IF (MOUT.LT.0.AND.LOUT.GT.0) THEN
    CALL UOTES6(NF,NA,NAL,NC,NCL,XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,
   &  RPF4,RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,
   &  ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
   &  ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
   &  MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
   &  MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
   &  MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
   &  MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
   &  MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
   &  KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,MF,MA,MB,
   &  KSF,KCF,KSA,KCA,KSC,KCC)
    ENDIF
    $IF(COLLECTION='PROFILE')
      CLOSE(7)
      $IF(PROFILE<>'NO')
        OPEN(7,FILE='P.PER',STATUS='UNKNOWN')
        OPEN(8,FILE='P.PRO',STATUS='UNKNOWN')
        CALL UOTES7('$$PROFILE',$$BOUND)
        CLOSE(7)
        CLOSE(8)
      $ENDIF
    $ENDIF
    CLOSE(2)
    CLOSE(3)
    END
    $OPTION(IUNIT=INITUNIT)
  $ENDSET
$ENDIF

$IF($DEF(PINIT))
  $PINIT
  $ERASE(PINIT)
$ENDIF
$SET(INIT)
  *
  *     ------------------------
  *     INITIATION OF METHOD ($NMET)
  *     ------------------------
  *
  SUBROUTINE UYINT$NMET
  $INCLUDE('UMCOMN')
  $IF(GRAPH<>'NO') $INCLUDE('UMCOMG')
  $IF(GRAPH<>'NO')
  NGR=0
  $ENDIF
$ENDSET
$METHODINIT=.TRUE.
  *
  *     ----------
  *     METHOD ($NMET)
  *     ----------
  *
CALL UYINT$NMET

$IF(NEWMODEL)
  $INPUTUSR=INPUT
  $INPUT=UFOINPUT
$ENDIF
$IF(NEWRUN)
  $IF(COLLECTION<>'NO')
    $IF(COLLECTION='PROFILE')
      $HELP
        NAME OF METHOD (TEN CHARACTERS AT MOST)
      $CHECK(NAME,'METHOD',STR,1,NO)
      CALL UOTES2(NAME)
      $ADD(INIT)
        NAME='$NAME'
      $ENDADD
    $ENDIF
    $IF(TESTCYCLE='YES')
      $ENDTEST=$99
    $ELSE
      $ENDTEST=$11
    $ENDIF
    $IF(TESTCYCLE='YES')
      DO $99 NEXT=1,$NEXT
    $ELSE
      NEXT=0
$11  CONTINUE
      IF (NEXT.GE.$NEXT) GO TO $99
      NEXT=NEXT+1
    $ENDIF
    $IF(COLLECTION<>'PROFILE')
      $HELP
        USER SUPPLIED CYCLE:

          HERE THE USER SUPPLIED STATEMENTS BEGINNING THE CYCLE
          ARE DEFINED.

      $CHECK(INITCYCLE,' ',STR,1,NO)
      $INITCYCLE
      $IF(INITCYCLE<>' ') $TSTART
    $ENDIF
    CALL UYTES2(NF,NC,NA,NE)
    $IF(COLLECTION='PROFILE')
      $IF(REPEATED>1)
        $IF(TESTCYCLE='YES')
          DO $98 NCYC=1,$REPEATED
        $ELSE
          NCYC=0
$12       CONTINUE
          IF (NCYC.GE.$REPEATED) GO TO $98
          NCYC=NCYC+1
        $ENDIF
      $ELSE
        NCYC=1  
      $ENDIF
    $ELSE
      NCYC=1  
    $ENDIF  
    $SET(ENDCYCLE)
      $IF(COLLECTION='EXTENDED')
        $ADD(INTEGER,'\NITF($NEXT)\NFVF($NEXT)\NFGF($NEXT)\NFHF($NEXT)&
        \NDCF($NEXT)\NCGF($NEXT)\NLSF($NEXT)\NTMF($NEXT)')
        CALL UYTES4(NITF,NFVF,NFGF,NFHF,NDCF,NCGF,NLSF,NTMF,$NEXT,GMAX&
,$$EQUATIONS)
        $HELP
          USER SUPPLIED OUTPUT:

            HERE THE RESULTS OBTAINED IN THE OPTIMIZATION PROCESS
            CAN BE USED FOR ADDITIONAL COMPUTATIONS AND FOR A
            SPECIFIC OUTPUT.

        $CHECK(OUTPUT,' ',STR,1,NO)
        $IF(DIA>0) $OPTION(LFORTO=.FALSE.)
        $$OUTPUT
        $OPTION(LFORTO=.TRUE.)
        $IF(TESTCYCLE='YES')
          $$ENDTEST CONTINUE
        $ELSE
          GO TO $11
$99       CONTINUE
        $ENDIF
        CALL UOTES5(NITF,NFVF,NFGF,NFHF,NDCF,NCGF,NLSF,NTMF,$NEXT)
      $ELSE
        $IF(COLLECTION='PROFILE')
          $IF(REPEATED>1)
            $IF(TESTCYCLE='YES')
$98           CONTINUE
            $ELSE
              GO TO $12
$98           CONTINUE
            $ENDIF
          $ENDIF
        $ENDIF
        CALL UYTES3(GMAX,$$EQUATIONS)
        $IF(COLLECTION='PROFILE')
          $IF(PROFDATA='ABSOLUTE')
            CALL UOTES3(1)
          $ELSE
            CALL UOTES3(2)
          $ENDIF  
        $ENDIF
        $HELP
          USER SUPPLIED OUTPUT:

            HERE THE RESULTS OBTAINED IN THE OPTIMIZATION PROCESS
            CAN BE USED FOR ADDITIONAL COMPUTATIONS AND FOR A
            SPECIFIC OUTPUT.

        $CHECK(OUTPUT,' ',STR,1,NO)
        $IF(DIA>0) $OPTION(LFORTO=.FALSE.)
        $$OUTPUT
        $OPTION(LFORTO=.TRUE.)
        $IF(COLLECTION<>'PROFILE')
          $IF(INITCYCLE<>' ')
            $TSTOP
          $ENDIF
        $ENDIF  
        $IF(TESTCYCLE='YES')
          $$ENDTEST CONTINUE
        $ELSE
          GO TO $11
$99       CONTINUE
        $ENDIF
        CALL UOTES4
      $ENDIF
$REM      $ERASE(COLLECTION)
    $ENDSET
  $ELSE
$REM    $SET(ENDCYCLE)
$REM       $ENDTEST=$99
$REM $99   CONTINUE
$REM    $ENDSET
    $IF($DEF(ENDCYCLE)) $ERASE(ENDCYCLE)
  $ENDIF
$ENDIF


