$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMODC                                    01/12/97  +
$REM + SI                                                            +
$REM + PURPOSE:  SPECIFICATION OF MODEL OF CONSTRAINT FUNCTIONS      +
$REM +---------------------------------------------------------------+

$LDC=-1
$GMODC='X'
$HMODC='X'
$IF($DEF(FMODELCS))
  $FMODELC=FMODELCS
  $ERASE(FMODELCS)
  $ISNC=1
  $LDC=0
$ENDIF
$IF($DEF(FMODELC))
  $FMODC='F'
  $KDC=0
  $IF($DEF(GMODELCS))
    $IF(LDC<0)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDC < 0
      $STOP
    $ENDIF
    $GMODELC=GMODELCS
    $ERASE(GMODELCS)
    $ISNC=2
    $LDC=1
  $ENDIF
  $IF($DEF(GMODELC))
    $GMODC='G'
    $KDC=1
  $ENDIF
  $IF($DEF(HMODELCS))
    $IF(LDC<1)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDC < 1
      $STOP
    $ENDIF
    $HMODELC=HMODELCS
    $ERASE(HMODELCS)
    $LDC=2
  $ENDIF
  $IF($DEF(HMODELC))
    $HMODC='H'
    $KDC=2
  $ENDIF
  $MODELC='YES'
  $EXIT
$ENDIF
$IF($DEF(FGMODELCS))
  $FGMODELC=FGMODELCS
  $ERASE(FGMODELCS)
  $ISNC=2
  $LDC=1
$ENDIF
$IF($DEF(FGMODELC))
  $FMODC='FG'
  $KDC=1
  $IF($DEF(HMODELCS))
    $IF(LDC<1)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDC < 1
      $STOP
    $ENDIF
    $HMODELC=HMODELCS
    $ERASE(HMODELCS)
    $LDC=2
  $ENDIF
  $IF($DEF(HMODELC))
    $HMODC='H'
    $KDC=2
  $ENDIF
  $MODELC='YES'
  $EXIT
$ENDIF
$IF($DEF(FGHMODELCS))
  $FGHMODELC=FGHMODELCS
  $ERASE(FGHMODELCS)
  $ISNC=2
  $LDC=2
$ENDIF
$IF($DEF(FGHMODELC))
  $FMODC='FGH'
  $KDC=2
  $MODELC='YES'
  $EXIT
$ENDIF
$FMODC='F'
$KDC=0
$MODELC='YES'
$REPEAT
  $HELP
    MODEL OF THE APPROXIMATED FUNCTION

    FC = <FORTRAN_EXPRESSION>
  $CHECK(FMODELC,'*',STR,1,NO)
  $IF(FMODELC='*')
    $IF(DIALOG>0)
      $ERASE(FMODELC)
    $ELSE
      $ERROR:  MODEL OF CONSTRAINT FUNCTION WAS NOT SPECIFIED.
      $STOP
    $ENDIF
  $ENDIF
$UNTIL($DEF(FMODELC))
$HELP
  MODEL OF GRADIENT OF THE CONSTRAINT FUNCTION

    GC(1)  = <FORTRAN_EXPRESSION>
    GC(2)  = <FORTRAN_EXPRESSION>
      .
      .
    GC(NF) = <FORTRAN_EXPRESSION>
$CHECK(GMODELC,'*',STR,1,NO)
$IF(GMODELC='*')
  $ERASE(GMODELC)
$ELSE
  $GMODC='G'
  $KDC=1
$ENDIF
$HELP
  MODEL OF HESSIAN MATRIX

    HC(1) = <FORTRAN_EXPRESSION>
    HC(2) = <FORTRAN_EXPRESSION>
      .
      .
    HC(M) = <FORTRAN_EXPRESSION>
$CHECK(HMODELC,'*',STR,1,NO)
$IF(HMODELC='*')
  $ERASE(HMODELC)
$ELSE
  $HMODC='H'
  $KDC=2
$ENDIF

